



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>js四舍五入的bug和方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">js四舍五入的bug和方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 23:56:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<pre class="prettyprint linenums">简单来说js使用原生toFixed(x)截取小数的时候会有误差，出现在比如var o = 0.3303;o.toFixed(3);//0.330

toFixed(x)本来也是一个获取四舍五入的截取方法，但这个bug实在不能忍，所以还是用Math.round(x)比较稳定

toFixed(x)<br />在js中四舍五入的函数 tofixed(n) , n为要保留的小数位数。<br />n为0~20，当n超过20的时候，js会出错，这东西好像只能传一个数字进去，字符串会爆不是一个方法

var d=10.005;<br />d.toFixed(2);<br />//"10.01"

bug

var d=13.35;<br />d.toFixed(1);

//13.3

Number(13.35).toFixed(1); //13.3    //what's the hell！<br />Number(0.055).toFixed(1); //0.1

//如果要修改这个缺陷，可以把js中的number类型的tofixed方法重写。

round 方法<br />返回与给出的数值表达式最接近的整数。

math.round(number)<br />必选项 number 参数是要舍入到最接近整数的值。

说明<br />如果 number 的小数部分大于等于 0.5，返回值是大于 number 的最小整数。<br />否则，round 返回小于等于 number 的最大整数。

其实我们可以用一种更加简洁的方法来解决这个问题：用Math.round方法来实现四舍五入。

比如，四舍五入一个数字并保留小数点后两位，我们可以这么干：

Math.round(num * Math.pow(10, 2)) / Math.pow(10, 2);  //num是待处理数字<br />当num = 10.10500时，计算上述表达式可得10.11。（正常）

当num = "10.50000"时（注意这里是字符串），计算上述表达式可得10.5。（damn it，小数点后位数不对！）

.....

当num是字符串，进行乘法操作时，进行了类型转换，后缀零被丢弃了，导致位数不足，这个时候我们就应该进行补零：

(Math.round(num * Math.pow(10, 2)) / Math.pow(10, 2) + 0.001).toString().slice(0, -1) //加上一个小数点后多一位的数字0.001，再删除最后一个字符即可。<br />//slice(0, -1) 这个是截取一个对象或者数组的方法，表示取去除符合逻辑的其他对象，这里上下文是从转换成字符串之后的从0开始截取到倒数第一位的位置，就是把倒数第一位给干掉，因为手动加上了0.*1这个，所以要把多出来的那个1给干掉就刚好截取了

大概方法就是先剩10的n次方再除10的n次方，然后加上10的-（n+1）次方，转成字符串正好多了一位1，再用slice方法把这个1干掉，具体逻辑验证过了，可以直接用

综上，修正的toFixed计算表达式如下：

(Math.round(num * Math.pow(10, fractionDigits)) / Math.pow(10, fractionDigits) + Math.pow(10, -(fractionDigits + 1))).toString().slice(0, -1)<br />最终得到的截取小数位数计算方法为  <strong>(Math.round(num*Math.pow(10,fractionDigits))/Math.pow(10,fractionDigits)+Math.pow(10,-(fractionDigits+1))).toString().slice(0, -1)</strong>

我的截取小数方法

var iTofixed =function(num,fractionDigits) {

    return (Math.round(num*Math.pow(10,fractionDigits))/Math.pow(10,fractionDigits)+Math.pow(10,-(fractionDigits+1))).toString().slice(0, -1)

};

iTofixed('13.5000',3);<br />//"13.500"</pre>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2jryv8.html">webstorm2016注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oynelq.html">OC中copy的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0y5eq.html">python学习总结1</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mg3vp8.html">BZOJ3821 &colon; 玄学</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mm1jeq.html">Binary Tree Level Order Traversal &lbrack;LeetCode&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydy51dq.html">&lbrack;摘&rsqb;PE中安装Windows 7&sol;8</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnl322q.html">javascrip keyCode属性备案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxrk79.html">iPhone Tableview分批显示数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevrdj9.html">thinkphp 视图模型使用分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m22438.html">关于IIS强制配置启用IE8以上浏览器兼容打开系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk252z8.html">Python将列表中的string元素进行类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503lmm8.html">寒假学干货之------初步布局Layout</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkl60d8.html">关于安卓HTTP请求用HttpUrlConnection还是HttpClient好</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zop403q.html">简单的C语言编译器--语法分析器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gevk148.html">Python基本数据类型之列表、元组、字典、集合及其魔法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdelov9.html">oracle里面用sql做报表并带小计合计常用到的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll4v4eq.html">python基础4文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko40y5q.html">VS2015的对象浏览器的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvewnwo9.html">解决方案--duilib中edit获得鼠标焦点后右边框被覆盖</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kz31oq.html">STM32-增量式旋转编码器测量</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2w1xmvq.html">Mac下搭建Eclipse Android开发环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn4d1oq.html">SQL Server阻止了对组件xp&lowbar;cmdshell过程的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxngl1v8.html">MHz 和 Mbps的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1znjr9.html">if form1&period;showmodal&colon;&equals;mrok then  什么意思</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v5ev38.html">JavaScript之闭包与高阶函数（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdyrry8.html">MySQL基本配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdevggz9.html">构建ASP&period;NET MVC4&plus;EF5&plus;EasyUI&plus;Unity2&period;x注入的后台管理系统（26）-权限管理系统-分配角色给用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvwjpxq.html">如何在word2007中并排查看对比显示两个文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y13jjq.html">Swift --- 面向对象中类和对象的属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdevx509.html">mysql使用硬链接配合truncate 删除2&period;2T的表   --杨奇龙</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
